RGW does not support absolute URI
09/02/2015 11:39 AM - Wenjun Huang

Status: Resolved % Done: 0%
Priority: Normal Spent time: 0.00 hour
Assignee: Matt Benjamin

Category:

Target version:

Source: other Affected Versions: v0.94.2
Tags: ceph-qa-suite:

Backport: Pull request ID:

Regression: No Crash signature (v1):
Severity: 3 - minor Crash signature (v2):
Reviewed:

Description

When using goamz as the sdk to access rgw, it will fail. It is because that goamz send absoluteURI to RGW, It is similar to this issue.
For rgw, there are different failure reasons between civetweb and Apache as the frontend. They are described as below:

For civetweb:
civetweb does not support the resolving of absoluteURI, so it will fail very quickly with a "400 bad request error". | have made a issue
here to civetweb.

For Apache:

Apache will transfer the absoluteURI to rgw, but when doing the authorization, rgw will use the absoluteURI as the input for
calculating the signature, so it wont match the signature get from client's request(which is calculated depended on general URI). So it
will fail while doing authorization.

With apache as the frontend, | have hacked the source code of rgw, which adjust the req_info::request_uri to abs_path. So the
following reference to the req_info::request_uri will get the right value, so as the input for calculating the signature of server side. It
works well!

As far as | know, many languages's S3 sdk calculate the client side's signature using abs_path(l have tried Python, Java, Perl, Go).
So in my opinion, adjusting the req_info::request_uri to fix this issue is a right way, but | am not sure if it will influence any other part.

If you have any point please feel free to let me know.

Thanks

Related issues:
Duplicated by rgw - Bug #15231: radosgw returning 400 bad URI Duplicate 03/22/2016

Associated revisions

Revision 7032f99 - 02/29/2016 08:03 AM - wenjunhuang

rgw: adjust the request_uri to support absoluteURI of http request

http://tracker.ceph.com/issues/12917 Fixes: #12917

The requestURI transferred from the frontend can be abs_path or absoluteURI
If it is absoluteURI, we should adjust it to abs_path for the following

S3 authorization and some other processes depending on the requestURI
The absoluteURI can start with "http://", "https://", "ws://" or "wss:/"

Signed-off-by: Wenjun Huang <wenjunhuang@tencent.com>
History

#1 - 09/02/2015 12:02 PM - Wenjun Huang

| have made a pull request for my fix: https:/github.com/ceph/ceph/pull/5774

#2 - 09/08/2015 01:58 PM - Loic Dachary
- Project changed from Ceph to rgw

#3 - 03/21/2016 02:13 PM - Abhishek Lekshmanan
Upstream PR: https:/github.com/ceph/ceph/pull/7675

#4 - 03/21/2016 02:13 PM - Abhishek Lekshmanan

- Status changed from New to Resolved
#5 - 03/21/2016 03:30 PM - Abhishek Lekshmanan

- Status changed from Resolved to Fix Under Review

- Assignee set to Matt Benjamin

This might need a backport.. changing to need Review..

#6 - 03/22/2016 07:32 AM - Nathan Cutler
- Related to Bug #15231: radosgw returning 400 bad URI added

#7 - 03/22/2016 07:33 AM - Nathan Cutler
- Related to deleted (Bug #15231: radosgw returning 400 bad URI)

#8 - 03/22/2016 07:33 AM - Nathan Cutler
- Duplicated by Bug #15231: radosgw returning 400 bad URI added

#9 - 03/23/2016 06:38 PM - Yehuda Sadeh

- Status changed from Fix Under Review to Resolved

merged in here: https:/github.com/ceph/ceph/pull/7675
